// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TrajList.java

package edu.vt.traj;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

// Referenced classes of package edu.vt.traj:
//            RadiusTable, PDBStore

public class TrajList
{

    public void setGlobalResidueMax(int globalResidueMax)
    {
        this.globalResidueMax = globalResidueMax;
    }

    public void setGlobalResidueMin(int globalResidueMin)
    {
        this.globalResidueMin = globalResidueMin;
    }

    public int getName()
    {
        return name;
    }

    public TrajList(int name, File files[], java.awt.Color color, String cacheContacts)
    {
    	this.cacheContacts = cacheContacts;
        list = new ArrayList();
        contacts = new ArrayList();
        current = new int[2][2];
        dotSize = 8;
        percent = 0.5D;
        this.name = 0;
        window = 1;
        count = 0;
        index = 0;
        high = 0;
        low = 0;
        value = 0;
        active = true;
        
        
        title = "";
        filter = 1;
        trajResidueMax = 0;
        trajResidueMin = 49500;
        globalResidueMax = 0;
        globalResidueMin = 0;
        count = files.length;
        this.name = name;
        this.color = color;
        HashMap map = new HashMap();
        try
        {
            String line = "";
            for(int i = 0; i < files.length; i++)
                list.add(files[i].getAbsolutePath());

        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        sortList(list);
        loadPDB();
        index_start =  this.trajResidueMin;
        index_stop =  this.trajResidueMax;
    }

    private void sortList(List list)
    {
        Collections.sort(list, new Comparator() {

            public int compare(Object o1, Object o2)
            {
                int s1 = number(name((String)o1));
                int s2 = number(name((String)o2));
                return s1 - s2;
            }

            private String name(String s)
            {
                StringTokenizer s1 = new StringTokenizer(s, "\\/");
                String last;
                for(last = ""; s1.hasMoreTokens(); last = s1.nextToken());
                return last;
            }

            private int number(String s)
            {
                Pattern p = Pattern.compile(".*[^\\d](\\d+)[^\\d].*");
                Matcher m = p.matcher(" " + s + " ");
                boolean b = false;
                int num = 0;
                try
                {
                    b = m.matches();
                    String str = m.group(1);
                    num = Integer.parseInt(str);
                }
                catch(NumberFormatException e)
                {
                    e.printStackTrace();
                }
                return num;
            }

        });
    }

    private void loadPDB()
    {
        RadiusTable rad = new RadiusTable("atomNames", "atomRadii");
        for(int i = 0; i < list.size(); i++)
        {
            PDBStore pdb = new PDBStore((String)list.get(i), rad, cacheContacts);
            if(pdb.getMaxResidue() > trajResidueMax)
                trajResidueMax = pdb.getMaxResidue();
            if(pdb.getMinResidue() < trajResidueMin)
                trajResidueMin = pdb.getMinResidue();
            contacts.add(pdb.getData());
        }

    }

    public void range()
    {
        range(getIndex(), getIndex() + getWindow());
    }

    public void range(int value)
    {
        range(value, value + getWindow());
    }

    public void range(int start, int stop)
    {
        size = this.trajResidueMax - this.trajResidueMin+2;
        int tmp[][] = new int[size][size];
        for(int i = start; i < stop; i++)
        {
            int d[][] = (int[][])contacts.get(i);
            for(int j = 0; j < d.length; j++)
                tmp[d[j][0]][d[j][1]]++;

        }

        int range = stop - start;
        double cutoff = (double)range * percent;
        int count = 0;
        for(int i = 0; i < size; i++)
        {
            for(int j = i + filter; j < size; j++)
                if((double)tmp[i][j] >= cutoff)
                    count++;

        }

        int table[][] = new int[count][2];
        count = 0;
        for(int i = 0; i < size; i++)
        {
            for(int j = i + filter; j < size; j++)
                if((double)tmp[i][j] >= cutoff)
                {
                    table[count][0] = i;
                    table[count][1] = j;
                    count++;
                }

        }

        high = stop;
        low = start;
        current = table;
        loadCurrent(current);
        
    }

    private void loadCurrent(int[][] current2) {
		// TODO Auto-generated method stub
    	quickLook = new HashSet();
		for(int i = 0; i<current2.length; i++){
			quickLook.add(current[i][0]+delim+current[i][1]);
		}
	}

	public int[][] getCurrent()
    {
        return current;
    }

    public void setPercent(double percent)
    {
        this.percent = percent;
    }

    public int getWindow()
    {
        return window;
    }

    public void setWindow(int window)
    {
        this.window = window;
    }

    public boolean isActive()
    {
        return active;
    }

    public void setActive(boolean active)
    {
        this.active = active;
    }

    public java.awt.Color getColor()
    {
        return color;
    }

    public void setColor(java.awt.Color color)
    {
        this.color = color;
    }

    public String getTitle()
    {
        return title;
    }

    public void toggleActive()
    {
        active = !active;
    }
    
    public void toggleIntersect()
    {
        intersect = !intersect;
    }

    public void toggleDifference()
    {
        difference = !difference;
    }
    
    public void toggleVisable()
    {
        visable = !visable;
    }
    
    public int getFilter()
    {
        return filter;
    }

    public void setFilter(int filter)
    {
        this.filter = filter;
    }

    public int getIndex()
    {
        return index;
    }

    public void setIndex(int index)
    {
        this.index = index;
    }

    public int getHigh()
    {
        return high;
    }

    public int getLow()
    {
        return low;
    }

    public int getDotSize()
    {
        return dotSize;
    }

    public void setDotSize(int dotSize)
    {
        this.dotSize = dotSize;
    }

    public double getPercent()
    {
        return percent;
    }

    public int getCount()
    {
        return count;
    }

    public int getTrajResidueMax()
    {
        return trajResidueMax;
    }

    public int getTrajResidueMin()
    {
        return trajResidueMin;
    }

    public int getGlobalResidueMax()
    {
    	//System.out.println(this.globalResidueMax);
        return globalResidueMax;
    }

    public int getGlobalResidueMin()
    {
        return globalResidueMin;
    }

    List list;
    List contacts;
    int current[][];
    int size;
    int dotSize;
    double percent;
    int name;
    int window;
    int count;
    int index;
    java.awt.Color color;
    int high;
    int low;
    int value;
    boolean active;
    boolean intersect = false;
    boolean difference = false;
    boolean visable = true;
    String title;
    int filter;
    int trajResidueMax;
    int trajResidueMin;
    int globalResidueMax;
    int globalResidueMin;
    String delim = ":::";
    String cacheContacts;
    Set quickLook = new HashSet();
    int index_start = 0;
    int index_stop = 0;
    
    
	public boolean isDifference() {
		return difference;
	}

	public boolean isIntersect() {
		return intersect;
	}

	public boolean isVisable() {
		return visable;
	}

	public int getIndex_start() {
		return index_start;
	}

	public void setIndex_start(int index_start) {
		this.index_start = index_start;
	}

	public int getIndex_stop() {
		return index_stop;
	}

	public void setIndex_stop(int index_stop) {
		this.index_stop = index_stop;
	}
}
