// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   PDBStore.java

package edu.vt.traj;

import java.io.*;
import java.util.*;

// Referenced classes of package edu.vt.traj:
//            RadiusTable, Atom

public class PDBStore
{

    public static void main(String args[])
    {
        RadiusTable rad = new RadiusTable("data4", "data2");
        PDBStore pdb = new PDBStore("2MB5.pdb", rad,"true");  
        System.out.println(pdb.get(0).getType() + " " + pdb.get(0).getRadius());
        int data[][] = pdb.getData();
        for(int i = 0; i < data.length; i++)
            System.out.println(data[i][0] + " " + data[i][1]);

    }

    public PDBStore(String file, RadiusTable radius, String contactCache)
    {
    	this.contactCache = contactCache;
        atoms = new ArrayList();
        minResidue = 500;
        maxResidue = 0;
        max = 0x80000000;
        min = 0x7fffffff;
        diameterWater = 2.7999999999999998D;
        this.file = file;
        this.radius = radius;
        String line = "";
        diameterWater = 2D * radius.get("WATER");
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        try
        {
            reader = new BufferedReader(new FileReader(file));
        }
        catch(Exception e)
        {
          //  e.printStackTrace();
        }
        try
        {
            line = reader.readLine();
        }
        catch(Exception e)
        {
          //  e.printStackTrace();
        }
        while(line != null) 
        {
            if(line.length() > 50 && line.substring(0, 4).equals("ATOM"))
            {
                String index = line.substring(6, 11);
                String type = line.substring(12, 16);
                String resType = line.substring(17, 20);
                String resIndex = line.substring(22, 26);
                String xs = line.substring(30, 38);
                String ys = line.substring(38, 46);
                String zs = line.substring(46, 54);
                int iA = 1;
                int iR = 1;
                double x = 0.0D;
                double y = 0.0D;
                double z = 0.0D;
                try
                {
                    iA = Integer.parseInt(stripSpaces(index));
                    iR = Integer.parseInt(stripSpaces(resIndex));
                    if(iR > max)
                        max = iR;
                    if(iR < min)
                        min = iR;
                    x = Double.parseDouble(stripSpaces(xs));
                    y = Double.parseDouble(stripSpaces(ys));
                    z = Double.parseDouble(stripSpaces(zs));
                }
                catch(Exception e)
                {
                   // e.printStackTrace();
                }
                Atom at = new Atom(iA, type, resType, iR, x, y, z);
                at.setRadius(radius.get(type));
                atoms.add(at);
            }
            try
            {
                line = reader.readLine();
            }
            catch(Exception e)
            {
               // e.printStackTrace();
            }
        }
        protStats();
    }

    private String stripSpaces(String id)
    {
        String result = id.replaceAll("^\\s+", "");
        result = result.replaceAll("\\s+$", "");
        return result;
    }

    private void atomBin()
    {
        int maxz = 0;
        for(Iterator i = atoms.iterator(); i.hasNext();)
        {
            Atom a = (Atom)i.next();
            if(a.getResIndex() > maxz)
                maxz = a.getResIndex();
        }

        bin = new ArrayList[getMaxResidue() + 1];
        for(int i = 0; i < bin.length; i++)
            bin[i] = new ArrayList();

        Atom a;
        for(Iterator i = atoms.iterator(); i.hasNext(); bin[a.getResIndex()].add(a))
            a = (Atom)i.next();

    }

    public Atom get(int i)
    {
        return (Atom)atoms.get(i);
    }

    private void calculateContacts2()
    {
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));
        try
        {
            bw = new BufferedWriter(new FileWriter(cacheName(file)));
        }
        catch(Exception e)
        {
          //  e.printStackTrace();
        }
        atomBin();
        int table[][] = new int[protLength()][protLength()];
        for(int i = 0; i < table.length; i++)
        {
            for(int j = i + 1; j < table.length; j++)
                if(inContact(i, j))
                    table[i][j]++;

        }

        int count = 0;
        for(int i = 0; i < table.length; i++)
        {
            for(int j = i; j < table.length; j++)
                if(table[i][j] > 0)
                    count++;

        }

        data = new int[count][2];
        count = 0;
        for(int i = 0; i < table.length; i++)
        {
            for(int j = i; j < table.length; j++)
                if(table[i][j] > 0)
                {
                    data[count][0] = i;
                    data[count][1] = j;
                    count++;
                    try
                    {
                        bw.write(i + " " + j + "\n");
                    }
                    catch(Exception e)
                    {
                      //  e.printStackTrace();
                    }
                }

        }

        try
        {
            bw.close();
        }
        catch(Exception e)
        {
          //  e.printStackTrace();
        }
    }

    private boolean inContact(int ix, int iy)
    {
        if(Math.abs(ix - iy) < 2)
            return true;
        for(int indexi = 0; indexi < bin[ix].size(); indexi++)
        {
            for(int indexj = 0; indexj < bin[iy].size(); indexj++)
            {
                Atom a = (Atom)bin[ix].get(indexi);
                Atom b = (Atom)bin[iy].get(indexj);
                double distance = Math.sqrt(Math.pow(a.getX() - b.getX(), 2D) + Math.pow(a.getY() - b.getY(), 2D) + Math.pow(a.getZ() - b.getZ(), 2D));
                if(distance - a.getRadius() - b.getRadius() < diameterWater)
                    return true;
            }

        }

        return false;
    }

    public void protStats()
    {
        for(Iterator i = atoms.iterator(); i.hasNext();)
        {
            Atom a = (Atom)i.next();
            if(a.getResIndex() > maxResidue)
                maxResidue = a.getResIndex();
            if(a.getResIndex() < minResidue)
                minResidue = a.getResIndex();
        }

    }
    
    private String cacheName(String name){
    	//String result = "";
    	File file = new File(name);
    	//System.out.println("cache file is: "+file.getParent()+File.separator+"ZZZcontacts_"+file.getName() );
    	return file.getParent()+File.separator+"ZZZcontacts_"+file.getName();
    	//return result;
    }

    public int[][] getData()
    {
    	if(!contactCache.equals("true")){calculateContacts2(); return data;}
        if(data == null)
            try
            {
                String l = "";
                BufferedReader br = new BufferedReader(new FileReader(cacheName(file)));
                l = br.readLine();
                List list = new ArrayList();
                for(; l != null; l = br.readLine())
                {
                    StringTokenizer t = new StringTokenizer(l);
                    int tmp[] = new int[2];
                    tmp[0] = Integer.parseInt(t.nextToken());
                    tmp[1] = Integer.parseInt(t.nextToken());
                    list.add(tmp);
                }

                data = new int[list.size()][2];
                int count = 0;
                for(Iterator i = list.iterator(); i.hasNext();)
                {
                    int d[] = (int[])i.next();
                    data[count][0] = d[0];
                    data[count][1] = d[1];
                    count++;
                }

            }
            catch(Exception e)
            {
               // e.printStackTrace();
                calculateContacts2();
            }
        return data;
    }

    public int getMaxResidue()
    {
        return maxResidue;
    }

    public int getMinResidue()
    {
        return minResidue;
    }

    public int protLength()
    {
        return maxResidue - minResidue+2;
    }

    List atoms;
    String file;
    int data[][];
    List bin[];
    int minResidue;
    int maxResidue;
    RadiusTable radius;
    int max;
    int min;
    double diameterWater;
    String contactCache;
}
